Index: /trunk/SophyaExt/XephemAstroLib/astro.h
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/astro.h	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/astro.h	(revision 2551)
@@ -46,149 +573,233 @@
 /* global function declarations */
 
+
 /* aa_hadec.c */
-extern void aa_hadec P_((double lat, double alt, double az, double *ha,
-    double *dec));
-extern void hadec_aa P_((double lat, double ha, double dec, double *alt,
-    double *az)); 
+extern void aa_hadec (double lt, double alt, double az, double *ha,
+    double *dec);
+extern void hadec_aa (double lt, double ha, double dec, double *alt,
+    double *az); 
 
 /* aberration.c */
-extern void ab_ecl P_((double mjd, double lsn, double *lam, double *bet));
-extern void ab_eq P_((double mjd, double lsn, double *ra, double *dec));
+extern void ab_ecl (double m, double lsn, double *lam, double *bet);
+extern void ab_eq (double m, double lsn, double *ra, double *dec);
 
 /* airmass.c */
-extern void airmass P_((double aa, double *Xp));
+extern void airmass (double aa, double *Xp);
 
 /* anomaly.c */
-extern void anomaly P_((double ma, double s, double *nu, double *ea));
+extern void anomaly (double ma, double s, double *nu, double *ea);
+
+/* ap_as.c */
+extern void ap_as ( Now *np, double Mjd, double *rap, double *decp);
+extern void as_ap ( Now *np, double Mjd, double *rap, double *decp);
+
+/* atlas.c */
+extern char *um_atlas (double ra, double dec);
+extern char *u2k_atlas (double ra, double dec);
+extern char *msa_atlas (double ra, double dec);
+
+/* aux.c */
+extern double mm_mjed (Now *np);
 
 /* chap95.c */
-extern int chap95 P_((double mjd, int obj, double prec, double *ret));
+extern int chap95 (double m, int obj, double prec, double *ret);
 
 /* chap95_data.c */
 
+/* circum.c */
+extern int obj_cir (Now *np, Obj *op);
+
 /* comet.c */
-extern void comet P_((double mjd, double ep, double inc, double ap, double qp,
+extern void comet (double m, double ep, double inc, double ap, double qp,
     double om, double *lpd, double *psi, double *rp, double *rho, double *lam,
-    double *bet));
+    double *bet);
+
+/* constel.c */
+#define	NCNS	89
+extern int cns_pick (double r, double d, double e);
+extern int cns_id (char *abbrev);
+extern char *cns_name (int id);
+extern int cns_edges (double e, double **ra0p, double **dec0p, double **ra1p,
+    double **dec1p);
+extern int cns_list (double ra, double dec, double e, double rad, int ids[]);
+extern int cns_figure (int id, double e, double ra[],double dec[],int dcodes[]);
+extern int cns_reyfigure (int id, double e, double ra[], double dec[],
+    int dcodes[]);
+
+/* dbfmt.c */
+extern int db_crack_line (char s[], Obj *op, char nm[][MAXNM], int nnm,
+    char whynot[]);
+extern void db_write_line (Obj *op, char *lp);
+extern int dbline_candidate (char line[]);
+extern int get_fields (char *s, int delim, char *fields[]);
+extern int db_tle (char *name, char *l1, char *l2, Obj *op);
+extern int dateRangeOK (Now *np, Obj *op);
 
 /* deltat.c */
-extern double deltat P_((double mjd));
+extern double deltat (double m);
+
+/* earthsat.c */
+extern int obj_earthsat (Now *np, Obj *op);
 
 /* eq_ecl.c */
-extern void eq_ecl P_((double mjd, double ra, double dec, double *lat,
-    double *lng));
-extern void ecl_eq P_((double mjd, double lat, double lng, double *ra,
-    double *dec));
+extern void eq_ecl (double m, double ra, double dec, double *lt,double *lg);
+extern void ecl_eq (double m, double lt, double lg, double *ra,double *dec);
 
 /* eq_gal.c */
-extern void eq_gal P_((double mjd, double ra, double dec, double *lat,
-    double *lng));
-extern void gal_eq P_((double mjd, double lat, double lng, double *ra,
-    double *dec));
+extern void eq_gal (double m, double ra, double dec, double *lt,double *lg);
+extern void gal_eq (double m, double lt, double lg, double *ra,double *dec);
 
 /* formats.c */
-extern void fs_sexa P_((char *out, double a, int w, int fracbase));
-extern void fs_date P_((char out[], double jd));
-extern void f_scansex P_((double o, char *str, double *dp));
-extern void f_sscandate P_((char *bp, int pref, int *m, double *d, int *y));
-extern int scansex P_((char *str, double *dp));
+extern int fs_sexa (char *out, double a, int w, int fracbase);
+extern int fs_date (char out[], double jd);
+extern int f_scansexa (const char *str, double *dp);
+extern void f_sscandate (char *bp, int pref, int *m, double *d, int *y);
 
 /* helio.c */
-extern void heliocorr P_((double jd, double ra, double dec, double *hcp));
+extern void heliocorr (double jd, double ra, double dec, double *hcp);
+
+/* jupmoon.c */
+extern void jupiter_data (double Mjd, char dir[], Obj *eop, Obj *jop,
+    double *jupsize, double *cmlI, double *cmlII, MoonData md[J_NMOONS]); 
 
 /* libration.c */
-extern void llibration P_((double JD, double *llatp, double *llonp));
+extern void llibration (double JD, double *llatp, double *llonp);
+
+/* magdecl.c */
+extern int magdecl (double l, double L, double e, double y, char *dir,
+    double *dp, char *err);
+
+/* marsmoon.c */
+extern void marsm_data (double Mjd, char dir[], Obj *eop, Obj *mop,
+    double *marssize, MoonData md[M_NMOONS]); 
 
 /* misc.c */
-extern void zero_mem P_((void *loc, unsigned len));
-extern int tickmarks P_((double min, double max, int numdiv, double ticks[]));
-extern int lc P_((int cx, int cy, int cw, int x1, int y1, int x2, int y2,
-    int *sx1, int *sy1, int *sx2, int *sy2));
-extern void hg_mag P_((double h, double g, double rp, double rho, double rsn,
-    double *mp));
-extern int magdiam P_((int fmag, int magstp, double scale, double mag,
-    double size));
-extern void gk_mag P_((double g, double k, double rp, double rho, double *mp));
-extern double atod P_((char *buf));
-extern void solve_sphere P_((double A, double b, double cc, double sc,
-    double *cap, double *Bp));
-extern double delra P_((double dra));
+extern void zero_mem (void *loc, unsigned len);
+extern int tickmarks (double min, double max, int numdiv, double ticks[]);
+extern int lc (int cx, int cy, int cw, int x1, int y1, int x2, int y2,
+    int *sx1, int *sy1, int *sx2, int *sy2);
+extern void hg_mag (double h, double g, double rp, double rho, double rsn,
+    double *mp);
+extern int magdiam (int fmag, int magstp, double scale, double mag,
+    double size);
+extern void gk_mag (double g, double k, double rp, double rho, double *mp);
+extern double atod (char *buf);
+extern void solve_sphere (double A, double b, double cc, double sc,
+    double *cap, double *Bp);
+extern double delra (double dra);
+extern void now_lst (Now *np, double *lstp);
+extern void radec2ha (Now *np, double ra, double dec, double *hap);
+extern char *obj_description (Obj *op);
+extern int is_deepsky (Obj *op);
 
 /* mjd.c */
-extern void cal_mjd P_((int mn, double dy, int yr, double *mjd));
-extern void mjd_cal P_((double mjd, int *mn, double *dy, int *yr));
-extern int mjd_dow P_((double mjd, int *dow));
-extern int isleapyear P_((int year));
-extern void mjd_dpm P_((double mjd, int *ndays));
-extern void mjd_year P_((double mjd, double *yr));
-extern void year_mjd P_((double y, double *mjd));
-extern void rnd_second P_((double *t));
-extern void mjd_dayno P_((double jd, int *yr, double *dy));
-extern double mjd_day P_((double jd));
-extern double mjd_hr P_((double jd));
-extern void range P_((double *v, double r));
+extern void cal_mjd (int mn, double dy, int yr, double *m);
+extern void mjd_cal (double m, int *mn, double *dy, int *yr);
+extern int mjd_dow (double m, int *dow);
+extern int isleapyear (int year);
+extern void mjd_dpm (double m, int *ndays);
+extern void mjd_year (double m, double *yr);
+extern void year_mjd (double y, double *m);
+extern void rnd_second (double *t);
+extern void mjd_dayno (double jd, int *yr, double *dy);
+extern double mjd_day (double jd);
+extern double mjd_hr (double jd);
+extern void range (double *v, double r);
+extern void radecrange (double *ra, double *dec);
 
 /* moon.c */
-extern void moon P_((double mjd, double *lam, double *bet, double *rho,
-    double *msp, double *mdp));
+extern void moon (double m, double *lam, double *bet, double *rho,
+    double *msp, double *mdp);
 
 /* mooncolong.c */
-extern void moon_colong P_((double jd, double lt, double lg, double *cp, double *kp, double *ap, double *sp));
+extern void moon_colong (double jd, double lt, double lg, double *cp,
+    double *kp, double *ap, double *sp);
+
+/* moonnf.c */
+extern void moonnf (double mj, double *mjn, double *mjf);
 
 /* nutation.c */
-extern void nutation P_((double mjd, double *deps, double *dpsi));
-extern void nut_eq P_((double mjd, double *ra, double *dec));
+extern void nutation (double m, double *deps, double *dpsi);
+extern void nut_eq (double m, double *ra, double *dec);
 
 /* obliq.c */
-extern void obliquity P_((double mjd, double *eps));
+extern void obliquity (double m, double *eps);
 
 /* parallax.c */
-extern void ta_par P_((double tha, double tdec, double phi, double ht,
-    double *rho, double *aha, double *adec));
+extern void ta_par (double tha, double tdec, double phi, double ht,
+    double *rho, double *aha, double *adec);
+
+/* parallactic.c */
+extern double parallacticLDA (double lt, double dec, double alt);
+extern double parallacticLHD (double lt, double ha, double dec);
 
 /* plans.c */
-extern void plans P_((double mjd, int p, double *lpd0, double *psi0,
+extern void plans (double m, PLCode p, double *lpd0, double *psi0,
     double *rp0, double *rho0, double *lam, double *bet, double *dia,
-    double *mag));
+    double *mag);
+
+/* plshadow.c */
+extern int plshadow (Now *np, Obj *op, Obj *sop, double polera,
+double poledec, double x, double y, double z, double *sxp, double *syp);
+
+/* plmoon_cir.c */
+extern int plmoon_cir (Now *np, Obj *moonop);
+extern int getBuiltInObjs (Obj **opp);
+extern void setMoonDir (char *dir);
 
 /* precess.c */
-extern void precess P_((double mjd1, double mjd2, double *ra, double *dec));
+extern void precess (double mjd1, double mjd2, double *ra, double *dec);
 
 /* reduce.c */
-extern void reduce_elements P_((double mjd0, double mjd, double inc0,
-    double ap0, double om0, double *inc, double *ap, double *om));
+extern void reduce_elements (double mjd0, double m, double inc0,
+    double ap0, double om0, double *inc, double *ap, double *om);
 
 /* refract.c */
-extern void unrefract P_((double pr, double tr, double aa, double *ta));
-extern void refract P_((double pr, double tr, double ta, double *aa));
+extern void unrefract (double pr, double tr, double aa, double *ta);
+extern void refract (double pr, double tr, double ta, double *aa);
 
 /* rings.c */
-extern void satrings P_((double sb, double sl, double sr, double el, double er,
-    double JD, double *etiltp, double *stiltp));
+extern void satrings (double sb, double sl, double sr, double el, double er,
+    double JD, double *etiltp, double *stiltp);
 
 /* riset.c */
-extern void riset P_((double ra, double dec, double lat, double dis,
-    double *lstr, double *lsts, double *azr, double *azs, int *status));
+extern void riset (double ra, double dec, double lt, double dis,
+    double *lstr, double *lsts, double *azr, double *azs, int *status);
+
+/* riset_cir.c */
+extern void riset_cir (Now *np, Obj *op, double dis, RiseSet *rp);
+extern void twilight_cir (Now *np, double dis, double *dawn, double *dusk,
+    int *status);
+
+/* satmoon.c */
+extern void saturn_data (double Mjd, char dir[], Obj *eop, Obj *sop,
+    double *satsize, double *etilt, double *stlit, MoonData md[S_NMOONS]); 
 
 /* sphcart.c */
-extern void sphcart P_((double l, double b, double r, double *x, double *y,
-    double *z));
-extern void cartsph P_((double x, double y, double z, double *l, double *b,
-    double *r));
+extern void sphcart (double l, double b, double r, double *x, double *y,
+    double *z);
+extern void cartsph (double x, double y, double z, double *l, double *b,
+    double *r);
 
 /* sun.c */
-extern void sunpos P_((double mjd, double *lsn, double *rsn, double *bsn));
+extern void sunpos (double m, double *lsn, double *rsn, double *bsn);
 
 /* twobody.c */
-extern void vrc P_((double *v, double *r, double tp, double e, double q));
+extern int vrc (double *v, double *r, double tp, double e, double q);
+
+/* umoon.c */
+extern void uranus_data (double Mjd, char dir[], Obj *eop, Obj *uop,
+    double *usize, MoonData md[U_NMOONS]); 
 
 /* utc_gst.c */
-extern void utc_gst P_((double mjd, double utc, double *gst));
-extern void gst_utc P_((double mjd, double gst, double *utc));
+extern void utc_gst (double m, double utc, double *gst);
+extern void gst_utc (double m, double gst, double *utc);
 
 /* vsop87.c */
-extern int vsop87 P_((double mjd, int obj, double prec, double *ret));
+extern int vsop87 (double m, int obj, double prec, double *ret);
+
+#endif /* _ASTRO_H */
 
 /* For RCS Only -- Do Not Edit
- * @(#) $RCSfile: astro.h,v $ $Date: 2001-10-22 12:08:26 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $
+ * @(#) $RCSfile: astro.h,v $ $Date: 2004-06-15 16:52:37 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $
  */
Index: /trunk/SophyaExt/XephemAstroLib/atlas.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/atlas.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/atlas.c	(revision 2551)
@@ -0,0 +1,196 @@
+/* look up which star atlas an ra/dec is in.
+ * Urano and Mill contributed by Atsuo Ohki <ohki@gssm.otsuka.tsukuba.ac.jp>
+ * U2K by Robert Lane <roblane@alum.mit.edu>
+ *
+ * N.B. skylist.c assumes a certain max length for any returned string.
+ */
+ 
+#include <stdio.h>
+#include <string.h>
+
+#include "astro.h"
+
+/* for Millennium Star Atlas */
+static int msa_charts[] = {
+    /* 90*/  2, /* 84*/  4, /* 78*/  8, /* 72*/ 10, /* 66*/ 12,
+    /* 60*/ 14, /* 54*/ 16, /* 48*/ 20, /* 42*/ 20, /* 36*/ 22,
+    /* 30*/ 22, /* 24*/ 24, /* 18*/ 24, /* 12*/ 24, /*  6*/ 24,
+    /*  0*/ 24,
+    /* -6*/ 24, /*-12*/ 24, /*-18*/ 24, /*-24*/ 24, /*-30*/ 22,
+    /*-36*/ 22, /*-42*/ 20, /*-48*/ 20, /*-54*/ 16, /*-60*/ 14,
+    /*-66*/ 12, /*-72*/ 10, /*-78*/  8, /*-84*/  4, /*-90*/  2
+};
+
+/*
+ * find the chart number of Millennium Star Atlas and return pointer to static
+ * string describing location.
+ * 0 <= ra < 24;  -90 <= dec <= 90
+ */
+char *
+msa_atlas(double ra, double dec)
+{
+	static char buf[512];
+	int zone, band;
+	int i, p;
+
+	ra = radhr(ra);
+	dec = raddeg(dec);
+	buf[0] = 0;
+	if (ra < 0.0 || 24.0 <= ra || dec < -90.0 || 90.0 < dec)
+	    return (buf);
+	zone = (int)(ra/8.0);
+	band = -((int)(dec+((dec>=0)?3:-3))/6 - 15);
+	for (p=0, i=0; i <= band; i++)
+	    p += msa_charts[i];
+	i = (int)((ra - 8.0*zone) / (8.0/msa_charts[band]));
+	sprintf(buf, "V%d - P%3d", zone+1, p-i+zone*516);
+	return (buf);
+}
+
+/* for original Uranometria */
+static struct {
+    double l;
+    int n;
+} um_zones[] = {
+    /* 84 - 90 */ { 84.5,  2},
+    /* 72 - 85 */ { 72.5, 12},
+    /* 60 - 73 */ { 61.0, 20},
+    /* 49 - 62 */ { 50.0, 24},
+    /* 38 - 51 */ { 39.0, 30},
+    /* 27 - 40 */ { 28.0, 36},
+    /* 16 - 29 */ { 17.0, 45},
+    /*  5 - 18 */ {  5.5, 45},
+    /*  0 -  6 */ {  0.0, 45},
+		  {  0.0,  0}
+};
+
+/*
+ * find the chart number of Uranometria first edition and return pointer to
+ * static string describing location.
+ * 0 <= ra < 24;  -90 <= dec <= 90
+ */
+char *
+um_atlas(double ra, double dec)
+{
+	static char buf[512];
+	int band, south;
+	int p;
+	double w;
+
+	ra = radhr(ra);
+	dec = raddeg(dec);
+	buf[0] = 0;
+	if (ra < 0.0 || 24.0 <= ra || dec < -90.0 || 90.0 < dec)
+	    return (buf);
+	p = 0;
+	if (dec < 0.0) {
+	    dec = -dec;
+	    south = 1;
+	} else
+	    south = 0;
+	p = 1;
+	for (band=0; um_zones[band].n; band++) {
+	    if (um_zones[band].l <= dec)
+		break; 
+	    p += um_zones[band].n;
+	}
+	if (!um_zones[band].n)
+	    return (buf);
+	w = 24.0 / um_zones[band].n;
+	if (band) {
+	    ra += w/2.0;
+	    if (ra >= 24.0)
+		ra -= 24.0;
+	}
+	if (south && um_zones[band+1].n)
+	    p = 475 - p - um_zones[band].n;
+	if (south && band == 0) {
+	    /* south pole part is mis-ordered! */
+	    ra = 24.0 - ra;
+	}
+	sprintf(buf, "V%d - P%3d", south+1, p+(int)(ra/w));
+	return (buf);
+}
+
+/* for Uranometria 2000.0 */
+static struct {
+    double lowDec; 	/* lower dec cutoff */
+    int numZones;	/* number of panels (aka zones) */
+
+} u2k_zones[] = { /* array of book layout info */
+    /* 84 - 90 */ { 84.5,  1}, /* lower dec cutoff, # of panels in band */
+    /* 73 - 85 */ { 73.5,  6},
+    /* 62 - 74 */ { 62.0, 10},
+    /* 51 - 63 */ { 51.0, 12},
+    /* 40 - 52 */ { 40.0, 15},
+    /* 29 - 41 */ { 29.0, 18},
+    /* 17 - 30 */ { 17.0, 18},
+    /*  5 - 18 */ {  5.5, 20},
+    /*  0 -  6 */ {  0.0, 20},
+                  {  0.0,  0} /*numZones value in this line is a stopper.*/
+};
+
+/* find the chart number of Uranometria 2000.0 and return pointer to static
+ * string describing location.
+ * 0 <= ra < 24;  -90 <= dec <= 90
+ */
+char *
+u2k_atlas(double ra, double dec)
+{
+	static char buf[512];
+	static char err[] = "???";
+	int band; 		/* index to array */
+	int south;		/* flag for volume 2*/
+	int panel;		/* panel number */
+
+	ra = radhr(ra);
+	dec = raddeg(dec);
+	buf[0] = 0;
+	if (ra < 0.0 || 24.0 <= ra || dec < -90.0 || 90.0 < dec) {
+	    strcpy (buf, err);
+	    return (buf); /* range checking */
+	}
+
+	if (dec < 0.0) {
+	    dec = -dec;
+	    south = 1; /* South is mirror of North */
+	} else
+	    south = 0;
+
+	panel = 1;
+	band = 0;
+
+	/* scan u2k_zones for the correct band: */
+	while (u2k_zones[band].numZones != 0 && dec <= u2k_zones[band].lowDec ){
+	    panel += u2k_zones[band].numZones; /*accumulate total panels */
+	    band++ ;
+	}
+
+	if (!u2k_zones[band].numZones) { /* hit end of array with no match. */
+	    strcpy (buf, err);
+	    return (buf);
+	}
+
+	ra -= 12.0 / u2k_zones[band].numZones; /*offset by half-width of panel*/
+	if (ra >= 24.0)			/* reality check. shouldn't happen. */
+	    ra -= 24.0;
+
+	if (ra < 0.0)			/* offset could give negative ra */
+	    ra += 24.0;
+
+	if (south && u2k_zones[band+1].numZones)
+	    panel = 222 - panel - u2k_zones[band].numZones;
+
+	/* resultant panel number is accumulated panels in prior bands plus
+	 * ra's fraction of panels in dec's band. panel # goes up as ra goes
+	 * down.
+	 */
+	sprintf(buf, "V%d - P%3d", south+1,
+	panel+(int)(u2k_zones[band].numZones*(24.0 - ra)/24.0));
+
+	return (buf);
+}
+
+
+/* For RCS Only -- Do Not Edit */
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: atlas.c,v $ $Date: 2004-06-15 16:54:11 $ $Revision: 1.1 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/bdl.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/bdl.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/bdl.c	(revision 2551)
@@ -0,0 +1,234 @@
+/* crack natural satellite files from BDL */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+#include <unistd.h>
+
+#include "astro.h"
+#include "bdl.h"
+
+typedef enum {I, F, NL} ScanType;
+#define	SCANFLD(f,w,vp)	if(readField(fp,f,w,(void *)vp,ynot)<0) return (-1)
+
+static int readField (FILE *fp, ScanType f, int w, void *ptr, char ynot[]);
+static int readRec (FILE *fp, double *t0, double cmx[], double cfx[],
+    double cmy[], double cfy[], double cmz[], double cfz[], char ynot[]);
+
+/* given a sequencial text file in BDL natural satellite ephemeris format and a
+ * JD, find the x/y/z positions of each satellite. store in the given arrays,
+ * assumed to have one entry per moon. values are planetocentric, +x east, +y
+ * north, +z away from earth, all in au. corrected for light time.
+ * return the number of satellites or -1 and reason in ymot[].
+ * files obtained from ftp://ftp.bdl.fr/pub/misc/satxyz.
+ */
+int
+read_bdl (FILE *fp, double jd, double *xp, double *yp, double *zp, char ynot[])
+{
+	int npla;
+	int nsat;
+	int idn[8];
+	double freq[8];
+	double delt[8];
+	double djj;
+	double cmx[6], cfx[4], cmy[6], cfy[4], cmz[6], cfz[4];
+	int ienrf;
+	int jan;
+	int reclen;
+	long os0;
+	double t0;
+	int i;
+
+	/* read header line */
+	SCANFLD (I, 2, &npla);
+	SCANFLD (I, 2, &nsat);
+	for (i = 0; i < nsat; i++)
+	    SCANFLD (I, 5, &idn[i]);
+	for (i = 0; i < nsat; i++)
+	    SCANFLD (F, 8, &freq[i]);
+	for (i = 0; i < nsat; i++)
+	    SCANFLD (F, 5, &delt[i]);
+	SCANFLD (I, 5, &ienrf);
+	SCANFLD (F, 15, &djj);
+	SCANFLD (I, 5, &jan);
+	SCANFLD (NL, 0, NULL);
+
+	/* record position of first record */
+	os0 = ftell (fp);
+
+	/* read first record to get length */
+	reclen = readRec (fp, &t0, cmx, cfx, cmy, cfy, cmz, cfz, ynot);
+	if (reclen < 0)
+	    return (-1);
+
+	/* compute location of each satellite */
+	for (i = 0; i < nsat; i++) {
+	    int id = (int)floor((jd-djj)/delt[i]) + idn[i] - 2;
+	    long os = os0 + id*reclen;
+	    double t1, anu, tau, tau2, at;
+	    double tbx, tby, tbz;
+
+	    if (fseek (fp, os, SEEK_SET) < 0) {
+		sprintf (ynot, "Seek error to %ld for rec %d", os, id);
+		return (-1);
+	    }
+
+	    if (readRec (fp, &t0, cmx, cfx, cmy, cfy, cmz, cfz, ynot) < 0)
+		return (-1);
+
+	    t1 = floor(t0) + 0.5;
+	    anu = freq[i];
+	    tau = jd - t1;
+	    tau2 = tau * tau;
+	    at = tau*anu;
+
+	    tbx = cmx[0]+cmx[1]*tau+cmx[2]*sin(at+cfx[0])
+			    +cmx[3]*tau*sin(at+cfx[1])
+			    +cmx[4]*tau2*sin(at+cfx[2])
+			    +cmx[5]*sin(2*at+cfx[3]);
+	    tby = cmy[0]+cmy[1]*tau+cmy[2]*sin(at+cfy[0])
+			    +cmy[3]*tau*sin(at+cfy[1])
+			    +cmy[4]*tau2*sin(at+cfy[2])
+			    +cmy[5]*sin(2*at+cfy[3]);
+	    tbz = cmz[0]+cmz[1]*tau+cmz[2]*sin(at+cfz[0])
+			    +cmz[3]*tau*sin(at+cfz[1])
+			    +cmz[4]*tau2*sin(at+cfz[2])
+			    +cmz[5]*sin(2*at+cfz[3]);
+
+	    xp[i] = tbx*1000./149597870.;
+	    yp[i] = tby*1000./149597870.;
+	    zp[i] = tbz*1000./149597870.;
+	}
+
+	return (nsat);
+}
+
+/* read one field.
+ * return 0 if ok else -1
+ * N.B. this is enforce width, without skipping leading blanks.
+ */
+static int
+readField (FILE *fp, ScanType f, int width, void *ptr, char ynot[])
+{
+	char buf[128];
+	char *bp;
+
+	if (buf && width != (int)fread (buf, 1, width, fp)) {
+	    if (ferror(fp)) strcpy (ynot, "IO error");
+	    else if (feof(fp)) strcpy (ynot, "unexpected EOF");
+	    else strcpy (ynot, "short file");
+	    return (-1);
+	}
+
+	buf[width] = '\0';
+	switch (f) {
+	case I:
+	    *(int *)ptr = atoi (buf);
+	    break;
+	case F:
+	    bp = strchr (buf, 'D');
+	    if (bp)
+		*bp = 'e';
+	    *(double *)ptr = atof (buf);
+	    break;
+	case NL:
+	    fgets (buf, sizeof(buf), fp);
+	    break;
+	default:
+	    sprintf (ynot, "Bug! format = %d", f);
+	    return (-1);
+	}
+	return (0);
+}
+
+/* read one satellite record.
+ * return number of chars read else -1.
+ */
+static int
+readRec (FILE *fp, double *t0, double cmx[], double cfx[], double cmy[],
+double cfy[], double cmz[], double cfz[], char ynot[])
+{
+
+	long pos0, pos1;
+	int isat, idx;
+	int ldat1, ldat2;
+	int i;
+
+	pos0 = ftell (fp);
+
+	SCANFLD (I, 1, &isat);
+	SCANFLD (I, 5, &idx);
+	SCANFLD (I, 8, &ldat1);
+	SCANFLD (I, 8, &ldat2);
+	SCANFLD (F, 9, t0);
+	for (i = 0; i < 6; i++)
+	    SCANFLD (F, 17, &cmx[i]);
+	for (i = 0; i < 4; i++)
+	    SCANFLD (F, 17, &cfx[i]);
+	for (i = 0; i < 6; i++)
+	    SCANFLD (F, 17, &cmy[i]);
+	for (i = 0; i < 4; i++)
+	    SCANFLD (F, 17, &cfy[i]);
+	for (i = 0; i < 6; i++)
+	    SCANFLD (F, 17, &cmz[i]);
+	for (i = 0; i < 4; i++)
+	    SCANFLD (F, 17, &cfz[i]);
+	SCANFLD (NL, 0, NULL);
+
+	pos1 = ftell (fp);
+
+	return (pos1 - pos0);
+}
+
+
+#ifdef TEST_IT
+/* stand-alone test program.
+ * for example, compare
+ *   a.out jupiter.9910 2451910.50000
+ * with
+ *   satxyz2
+ *     jup.dir.9910
+ *     2001 1 1 0 0 0
+ *     1 0 0 0
+ *     1
+ */
+int
+main (int ac, char *av[])
+{
+	double x[10], y[10], z[10];
+	char ynot[1024];
+	double jd;
+	char *fn;
+	FILE *fp;
+	int nm;
+	int i;
+
+	if (ac != 3) {
+	    fprintf (stderr, "Usage: %s <filename> <jd>\n", av[0]);
+	    abort();
+	}
+	fn = av[1];
+	jd = atof (av[2]);
+
+	fp = fopen (fn, "r");
+	if (!fp) {
+	    perror (fn);
+	    abort();
+	}
+
+	nm = read_bdl (fp, jd, x, y, z, ynot);
+	if (nm < 0) {
+	    fprintf (stderr, "%s\n", ynot);
+	    abort();
+	}
+
+	for (i = 0; i < nm; i++)
+	    printf (" X= %19.11E Y= %19.11E Z= %19.11E\n", x[i], y[i], z[i]);
+
+	return (0);
+}
+#endif
+
+/* For RCS Only -- Do Not Edit */
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: bdl.c,v $ $Date: 2004-06-15 16:54:11 $ $Revision: 1.1 $ $Name: not supported by cvs2svn $"};
